//(c) 2000-2024 Cambridge University Technical Services Ltd
//All rights reserved
#include <phaser/lib/maths.h>
#include <map>

namespace phaser {

double lookup_sigesq_cent(double info)
{
  // Seed lookup tables with default target information content of 0.01 bits per
  // reflection plus some plausible other choices in range from 0.001 to 1.
  // For centrics, sigesq as a function of target for expected information is:
  std::map<double,double> sigesqs = {
    {0.001, 37.9612}, {0.00100323, 37.9}, {0.00100856, 37.8},
    {0.0010139, 37.7}, {0.00101929, 37.6}, {0.00102473, 37.5},
    {0.00103022, 37.4}, {0.00103575, 37.3}, {0.00104132, 37.2},
    {0.00104694, 37.1}, {0.0010526, 37.}, {0.00105831, 36.9},
    {0.00106406, 36.8}, {0.00106987, 36.7}, {0.00107572, 36.6},
    {0.00108161, 36.5}, {0.00108756, 36.4}, {0.00109356, 36.3},
    {0.0010996, 36.2}, {0.0011057, 36.1}, {0.00111185, 36.}, {0.00111804, 35.9},
    {0.00112429, 35.8}, {0.0011306, 35.7}, {0.00113695, 35.6},
    {0.00114336, 35.5}, {0.00114983, 35.4}, {0.00115635, 35.3},
    {0.00116292, 35.2}, {0.00116955, 35.1}, {0.00117624, 35.},
    {0.00118298, 34.9}, {0.00118979, 34.8}, {0.00119665, 34.7},
    {0.00120357, 34.6}, {0.00121055, 34.5}, {0.0012176, 34.4},
    {0.0012247, 34.3}, {0.00123187, 34.2}, {0.0012391, 34.1},
    {0.00124639, 34.}, {0.00125375, 33.9}, {0.00126117, 33.8},
    {0.00126866, 33.7}, {0.00127622, 33.6}, {0.00128384, 33.5},
    {0.00129154, 33.4}, {0.0012993, 33.3}, {0.00130713, 33.2},
    {0.00131503, 33.1}, {0.00132301, 33.}, {0.00133106, 32.9},
    {0.00133918, 32.8}, {0.00134737, 32.7}, {0.00135565, 32.6},
    {0.00136399, 32.5}, {0.00137242, 32.4}, {0.00138092, 32.3},
    {0.00138951, 32.2}, {0.00139817, 32.1}, {0.00140691, 32.},
    {0.00141574, 31.9}, {0.00142465, 31.8}, {0.00143364, 31.7},
    {0.00144272, 31.6}, {0.00145189, 31.5}, {0.00146114, 31.4},
    {0.00147048, 31.3}, {0.00147992, 31.2}, {0.00148944, 31.1},
    {0.00149905, 31.}, {0.00150876, 30.9}, {0.00151857, 30.8},
    {0.00152847, 30.7}, {0.00153846, 30.6}, {0.00154856, 30.5},
    {0.00155875, 30.4}, {0.00156905, 30.3}, {0.00157944, 30.2},
    {0.00158994, 30.1}, {0.00160055, 30.}, {0.00161126, 29.9},
    {0.00162208, 29.8}, {0.00163301, 29.7}, {0.00164405, 29.6},
    {0.00165521, 29.5}, {0.00166647, 29.4}, {0.00167786, 29.3},
    {0.00168936, 29.2}, {0.00170097, 29.1}, {0.00171271, 29.},
    {0.00172457, 28.9}, {0.00173655, 28.8}, {0.00174866, 28.7},
    {0.0017609, 28.6}, {0.00177326, 28.5}, {0.00178576, 28.4},
    {0.00179838, 28.3}, {0.00181115, 28.2}, {0.00182404, 28.1},
    {0.00183708, 28.}, {0.00185026, 27.9}, {0.00186358, 27.8},
    {0.00187704, 27.7}, {0.00189065, 27.6}, {0.00190441, 27.5},
    {0.00191831, 27.4}, {0.00193238, 27.3}, {0.00194659, 27.2},
    {0.00196096, 27.1}, {0.0019755, 27.}, {0.00199019, 26.9},
    {0.00200505, 26.8}, {0.00202008, 26.7}, {0.00203528, 26.6},
    {0.00205065, 26.5}, {0.00206619, 26.4}, {0.00208191, 26.3},
    {0.00209781, 26.2}, {0.00211389, 26.1}, {0.00213017, 26.},
    {0.00214662, 25.9}, {0.00216327, 25.8}, {0.00218011, 25.7},
    {0.00219715, 25.6}, {0.00221439, 25.5}, {0.00223184, 25.4},
    {0.00224949, 25.3}, {0.00226735, 25.2}, {0.00228542, 25.1},
    {0.00230372, 25.}, {0.00232223, 24.9}, {0.00234096, 24.8},
    {0.00235993, 24.7}, {0.00237912, 24.6}, {0.00239855, 24.5},
    {0.00241822, 24.4}, {0.00243813, 24.3}, {0.00245829, 24.2},
    {0.0024787, 24.1}, {0.00249936, 24.}, {0.00252028, 23.9},
    {0.00254147, 23.8}, {0.00256293, 23.7}, {0.00258465, 23.6},
    {0.00260666, 23.5}, {0.00262895, 23.4}, {0.00265152, 23.3},
    {0.00267439, 23.2}, {0.00269755, 23.1}, {0.00272101, 23.},
    {0.00274478, 22.9}, {0.00276887, 22.8}, {0.00279327, 22.7},
    {0.002818, 22.6}, {0.00284306, 22.5}, {0.00286845, 22.4},
    {0.00289418, 22.3}, {0.00292026, 22.2}, {0.00294669, 22.1},
    {0.00297349, 22.}, {0.00300065, 21.9}, {0.00302819, 21.8},
    {0.0030561, 21.7}, {0.0030844, 21.6}, {0.0031131, 21.5}, {0.0031422, 21.4},
    {0.00317171, 21.3}, {0.00320164, 21.2}, {0.00323199, 21.1},
    {0.00326278, 21.}, {0.003294, 20.9}, {0.00332568, 20.8}, {0.00335782, 20.7},
    {0.00339042, 20.6}, {0.0034235, 20.5}, {0.00345706, 20.4},
    {0.00349113, 20.3}, {0.00352569, 20.2}, {0.00356078, 20.1},
    {0.00359638, 20.}, {0.00363253, 19.9}, {0.00366922, 19.8},
    {0.00370647, 19.7}, {0.00374429, 19.6}, {0.00378269, 19.5},
    {0.00382169, 19.4}, {0.00386129, 19.3}, {0.0039015, 19.2},
    {0.00394235, 19.1}, {0.00398385, 19.}, {0.004026, 18.9}, {0.00406882, 18.8},
    {0.00411233, 18.7}, {0.00415654, 18.6}, {0.00420146, 18.5},
    {0.00424712, 18.4}, {0.00429352, 18.3}, {0.00434069, 18.2},
    {0.00438864, 18.1}, {0.00443739, 18.}, {0.00448695, 17.9},
    {0.00453735, 17.8}, {0.0045886, 17.7}, {0.00464072, 17.6},
    {0.00469373, 17.5}, {0.00474766, 17.4}, {0.00480252, 17.3},
    {0.00485834, 17.2}, {0.00491513, 17.1}, {0.00497292, 17.}, {0.005, 16.9537},
    {0.00503174, 16.9}, {0.0050916, 16.8}, {0.00515254, 16.7},
    {0.00521458, 16.6}, {0.00527774, 16.5}, {0.00534206, 16.4},
    {0.00540756, 16.3}, {0.00547426, 16.2}, {0.00554221, 16.1},
    {0.00561143, 16.}, {0.00568195, 15.9}, {0.00575381, 15.8},
    {0.00582704, 15.7}, {0.00590167, 15.6}, {0.00597774, 15.5},
    {0.00605529, 15.4}, {0.00613436, 15.3}, {0.00621498, 15.2},
    {0.0062972, 15.1}, {0.00638106, 15.}, {0.0064666, 14.9}, {0.00655388, 14.8},
    {0.00664292, 14.7}, {0.0067338, 14.6}, {0.00682654, 14.5},
    {0.00692121, 14.4}, {0.00701786, 14.3}, {0.00711655, 14.2},
    {0.00721733, 14.1}, {0.00732025, 14.}, {0.0074254, 13.9},
    {0.00753281, 13.8}, {0.00764258, 13.7}, {0.00775475, 13.6},
    {0.00786941, 13.5}, {0.00798662, 13.4}, {0.00810646, 13.3},
    {0.00822902, 13.2}, {0.00835437, 13.1}, {0.00848259, 13.},
    {0.00861379, 12.9}, {0.00874805, 12.8}, {0.00888546, 12.7},
    {0.00902613, 12.6}, {0.00917015, 12.5}, {0.00931764, 12.4},
    {0.00946871, 12.3}, {0.00962347, 12.2}, {0.00978205, 12.1}, {0.00994456, 12.},
    {0.01, 11.96642}, {0.0101111, 11.9}, {0.0102819, 11.8}, {0.0104571, 11.7},
    {0.0106367, 11.6}, {0.010821, 11.5}, {0.0110102, 11.4},
    {0.0112043, 11.3}, {0.0114035, 11.2}, {0.0116081, 11.1}, {0.0118183, 11.},
    {0.0120342, 10.9}, {0.012256, 10.8}, {0.012484, 10.7},
    {0.0127184, 10.6}, {0.0129594, 10.5}, {0.0132073, 10.4}, {0.0134624, 10.3},
    {0.0137249, 10.2}, {0.0139951, 10.1}, {0.0142734, 10.},
    {0.01456, 9.9}, {0.0148552, 9.8}, {0.0151595, 9.7}, {0.0154732, 9.6},
    {0.0157967, 9.5}, {0.0161304, 9.4}, {0.0164747, 9.3}, {0.01683, 9.2},
    {0.017197, 9.1}, {0.017576, 9.}, {0.0179676, 8.9}, {0.0183723, 8.8},
    {0.0187908, 8.7}, {0.0192236, 8.6}, {0.0196715, 8.5}, {0.0201351, 8.4},
    {0.0206152, 8.3}, {0.0211125, 8.2}, {0.0216279, 8.1},
    {0.0221622, 8.}, {0.0227164, 7.9}, {0.0232915, 7.8}, {0.0238884, 7.7},
    {0.0245085, 7.6}, {0.0251527, 7.5}, {0.0258224, 7.4},
    {0.0265189, 7.3}, {0.0272437, 7.2}, {0.0279983, 7.1}, {0.0287843, 7.},
    {0.0296035, 6.9}, {0.0304577, 6.8}, {0.0313488, 6.7},
    {0.0322792, 6.6}, {0.0332509, 6.5}, {0.0342666, 6.4}, {0.0353287, 6.3},
    {0.0364402, 6.2}, {0.0376041, 6.1}, {0.0388236, 6.},
    {0.0401023, 5.9}, {0.0414439, 5.8}, {0.0428526, 5.7}, {0.0443329, 5.6},
    {0.0458894, 5.5}, {0.0475273, 5.4}, {0.0492524, 5.3}, {0.05, 5.25824},
    {0.0510706, 5.2}, {0.0529886, 5.1}, {0.0550136, 5.}, {0.0571535, 4.9},
    {0.0594167, 4.8}, {0.0618125, 4.7}, {0.0643512, 4.6},
    {0.0670438, 4.5}, {0.0699026, 4.4}, {0.0729409, 4.3}, {0.0761733, 4.2},
    {0.079616, 4.1}, {0.0832869, 4.}, {0.0872055, 3.9}, {0.0913934, 3.8},
    {0.0958748, 3.7}, {0.100676, 3.6}, {0.105827, 3.5}, {0.111361, 3.4},
    {0.117313, 3.3}, {0.123726, 3.2}, {0.130646, 3.1}, {0.138124, 3.},
    {0.146218, 2.9}, {0.154994, 2.8}, {0.164527, 2.7}, {0.174901, 2.6},
    {0.186214, 2.5}, {0.198576, 2.4}, {0.212115, 2.3}, {0.226978, 2.2},
    {0.243335, 2.1}, {0.261386, 2.}, {0.281365, 1.9}, {0.30355, 1.8},
    {0.32827, 1.7}, {0.35592, 1.6}, {0.386982, 1.5}, {0.422043, 1.4},
    {0.461832, 1.3}, {0.507269, 1.2}, {0.559526, 1.1}, {0.620135, 1.},
    {0.691138, 0.9}, {0.775336, 0.8}, {0.87671, 0.7}, {1., 0.600842}
    };
  for (std::map<double,double>::iterator iter = sigesqs.begin(); iter != sigesqs.end(); iter++)
    if (info == iter->first) return iter->second;
  if (info <= 0.001) return sigesqs[0.001];
  if (info >= 1.) return sigesqs[1.];
  double i1 = sigesqs.begin()->first;
  double s1 = sigesqs.begin()->second;
  double i2 = sigesqs.begin()->first;
  double s2 = sigesqs.begin()->second;
  for (std::map<double,double>::iterator iter = sigesqs.begin(); iter != sigesqs.end(); iter++)
  {
    if (info < iter->first)
    {
      i2 = iter->first;
      s2 = iter->second;
      break;
    }
    i1 = iter->first;
    s1 = iter->second;
  }
  double val(s1 + (info-i1)*(s2-s1)/(i2-i1));
  return val;
}

double lookup_sigesq_acent(double info)
{
  // For acentrics, sigesq as a function of target for expected information is:
  std::map<double,double> sigesqs = {
    {0.001, 26.843}, {0.00100321, 26.8},
    {0.00101074, 26.7}, {0.00101835, 26.6}, {0.00102604, 26.5},
    {0.00103382, 26.4}, {0.00104169, 26.3}, {0.00104966, 26.2},
    {0.00105771, 26.1}, {0.00106586, 26.}, {0.0010741, 25.9},
    {0.00108243, 25.8}, {0.00109087, 25.7}, {0.0010994, 25.6},
    {0.00110803, 25.5}, {0.00111677, 25.4}, {0.00112561, 25.3},
    {0.00113455, 25.2}, {0.00114361, 25.1}, {0.00115277, 25.},
    {0.00116204, 24.9}, {0.00117142, 24.8}, {0.00118092, 24.7},
    {0.00119053, 24.6}, {0.00120026, 24.5}, {0.00121011, 24.4},
    {0.00122008, 24.3}, {0.00123018, 24.2}, {0.0012404, 24.1},
    {0.00125075, 24.}, {0.00126123, 23.9}, {0.00127184, 23.8},
    {0.00128259, 23.7}, {0.00129347, 23.6}, {0.0013045, 23.5},
    {0.00131566, 23.4}, {0.00132697, 23.3}, {0.00133842, 23.2},
    {0.00135003, 23.1}, {0.00136178, 23.}, {0.00137369, 22.9},
    {0.00138575, 22.8}, {0.00139798, 22.7}, {0.00141037, 22.6},
    {0.00142292, 22.5}, {0.00143564, 22.4}, {0.00144853, 22.3},
    {0.0014616, 22.2}, {0.00147484, 22.1}, {0.00148827, 22.},
    {0.00150188, 21.9}, {0.00151568, 21.8}, {0.00152966, 21.7},
    {0.00154385, 21.6}, {0.00155823, 21.5}, {0.00157281, 21.4},
    {0.00158759, 21.3}, {0.00160259, 21.2}, {0.0016178, 21.1},
    {0.00163323, 21.}, {0.00164888, 20.9}, {0.00166475, 20.8},
    {0.00168086, 20.7}, {0.0016972, 20.6}, {0.00171378, 20.5},
    {0.0017306, 20.4}, {0.00174768, 20.3}, {0.001765, 20.2}, {0.00178259, 20.1},
    {0.00180044, 20.}, {0.00181856, 19.9}, {0.00183695, 19.8},
    {0.00185562, 19.7}, {0.00187458, 19.6}, {0.00189384, 19.5},
    {0.00191339, 19.4}, {0.00193324, 19.3}, {0.0019534, 19.2},
    {0.00197388, 19.1}, {0.00199469, 19.}, {0.00201583, 18.9},
    {0.0020373, 18.8}, {0.00205912, 18.7}, {0.00208129, 18.6},
    {0.00210382, 18.5}, {0.00212671, 18.4}, {0.00214999, 18.3},
    {0.00217364, 18.2}, {0.00219769, 18.1}, {0.00222214, 18.}, {0.002247, 17.9},
    {0.00227228, 17.8}, {0.00229799, 17.7}, {0.00232414, 17.6},
    {0.00235074, 17.5}, {0.00237779, 17.4}, {0.00240531, 17.3},
    {0.00243332, 17.2}, {0.00246182, 17.1}, {0.00249081, 17.},
    {0.00252033, 16.9}, {0.00255037, 16.8}, {0.00258095, 16.7},
    {0.00261209, 16.6}, {0.00264379, 16.5}, {0.00267607, 16.4},
    {0.00270895, 16.3}, {0.00274243, 16.2}, {0.00277654, 16.1},
    {0.00281129, 16.}, {0.0028467, 15.9}, {0.00288278, 15.8},
    {0.00291954, 15.7}, {0.00295702, 15.6}, {0.00299522, 15.5},
    {0.00303416, 15.4}, {0.00307387, 15.3}, {0.00311437, 15.2},
    {0.00315567, 15.1}, {0.00319779, 15.}, {0.00324076, 14.9},
    {0.00328461, 14.8}, {0.00332935, 14.7}, {0.00337501, 14.6},
    {0.00342161, 14.5}, {0.00346919, 14.4}, {0.00351776, 14.3},
    {0.00356736, 14.2}, {0.00361802, 14.1}, {0.00366976, 14.},
    {0.00372262, 13.9}, {0.00377662, 13.8}, {0.00383181, 13.7},
    {0.00388822, 13.6}, {0.00394588, 13.5}, {0.00400484, 13.4},
    {0.00406512, 13.3}, {0.00412677, 13.2}, {0.00418983, 13.1},
    {0.00425435, 13.}, {0.00432037, 12.9}, {0.00438794, 12.8},
    {0.0044571, 12.7}, {0.00452791, 12.6}, {0.00460041, 12.5},
    {0.00467468, 12.4}, {0.00475075, 12.3}, {0.00482869, 12.2},
    {0.00490856, 12.1}, {0.00499043, 12.}, {0.005, 11.9885}, {0.00507436, 11.9},
    {0.00516042, 11.8}, {0.00524869, 11.7}, {0.00533924, 11.6},
    {0.00543215, 11.5}, {0.00552751, 11.4}, {0.00562539, 11.3},
    {0.00572589, 11.2}, {0.00582911, 11.1}, {0.00593514, 11.},
    {0.00604408, 10.9}, {0.00615605, 10.8}, {0.00627115, 10.7},
    {0.0063895, 10.6}, {0.00651124, 10.5}, {0.00663647, 10.4},
    {0.00676535, 10.3}, {0.00689802, 10.2}, {0.00703462, 10.1},
    {0.0071753, 10.}, {0.00732025, 9.9}, {0.00746962, 9.8}, {0.0076236, 9.7},
    {0.00778239, 9.6}, {0.00794617, 9.5}, {0.00811517, 9.4},
    {0.00828961, 9.3}, {0.00846972, 9.2}, {0.00865576, 9.1}, {0.00884797, 9.},
    {0.00904665, 8.9}, {0.00925207, 8.8}, {0.00946456, 8.7}, {0.00968443, 8.6},
    {0.00991203, 8.5}, {0.01, 8.46225}, {0.0101477, 8.4}, {0.0103919, 8.3},
    {0.010645, 8.2}, {0.0109074, 8.1}, {0.0111796, 8.}, {0.0114621, 7.9},
    {0.0117554, 7.8}, {0.0120601, 7.7}, {0.0123767, 7.6},
    {0.012706, 7.5}, {0.0130485, 7.4}, {0.013405, 7.3}, {0.0137762, 7.2},
    {0.014163, 7.1}, {0.0145663, 7.}, {0.014987, 6.9}, {0.015426, 6.8},
    {0.0158846, 6.7}, {0.0163639, 6.6}, {0.016865, 6.5}, {0.0173895, 6.4},
    {0.0179386, 6.3}, {0.0185141, 6.2}, {0.0191175, 6.1},
    {0.0197507, 6.}, {0.0204158, 5.9}, {0.0211148, 5.8}, {0.0218501, 5.7},
    {0.0226243, 5.6}, {0.02344, 5.5}, {0.0243003, 5.4}, {0.0252086, 5.3},
    {0.0261683, 5.2}, {0.0271834, 5.1}, {0.0282582, 5.},
    {0.0293974, 4.9}, {0.0306063, 4.8}, {0.0318906, 4.7}, {0.0332565, 4.6},
    {0.0347112, 4.5}, {0.0362622, 4.4}, {0.0379183, 4.3},
    {0.0396889, 4.2}, {0.0415847, 4.1}, {0.0436176, 4.}, {0.045801, 3.9},
    {0.0481496, 3.8}, {0.05, 3.726149}, {0.0506803, 3.7}, {0.053412, 3.6},
    {0.0563661, 3.5}, {0.0595667, 3.4}, {0.0630413, 3.3}, {0.0668212, 3.2},
    {0.0709421, 3.1}, {0.075445, 3.}, {0.0803769, 2.9}, {0.0857921, 2.8},
    {0.0917534, 2.7}, {0.0983335, 2.6}, {0.1, 2.57619}, {0.105617, 2.5}, {0.113704, 2.4},
    {0.122711, 2.3}, {0.132775, 2.2}, {0.14406, 2.1}, {0.15676, 2.},
    {0.171108, 1.9}, {0.187384, 1.8}, {0.205931, 1.7}, {0.227165, 1.6},
    {0.251599, 1.5}, {0.279873, 1.4}, {0.312792, 1.3}, {0.351381, 1.2},
    {0.396965, 1.1}, {0.451285, 1.}, {0.516685, 0.9}, {0.596388, 0.8},
    {0.694989, 0.7}, {0.819297, 0.6}, {0.979982, 0.5}, {1., 0.489288}
    };
  for (std::map<double,double>::iterator iter = sigesqs.begin(); iter != sigesqs.end(); iter++)
    if (info == iter->first) return iter->second;
  if (info <= 0.001) return sigesqs[0.001];
  if (info >= 1.) return sigesqs[1.];
  double i1 = sigesqs.begin()->first;
  double s1 = sigesqs.begin()->second;
  double i2 = sigesqs.begin()->first;
  double s2 = sigesqs.begin()->second;
  for (std::map<double,double>::iterator iter = sigesqs.begin(); iter != sigesqs.end(); iter++)
  {
    if (info < iter->first)
    {
      i2 = iter->first;
      s2 = iter->second;
      break;
    }
    i1 = iter->first;
    s1 = iter->second;
  }
  double val(s1 + (info-i1)*(s2-s1)/(i2-i1));
  return val;
}

}
